.de BX
.sp
.nf
.in +5
.ft C
..
.de EX
.ft P
.fi
.sp
.in -5
..
.TH XROOMS 1 "Contrib" "X Version 11"
.SH NAME
xrooms \- rooms for X
.SH SYNOPSIS
.B xrooms
[-\fItoolkitoption\fP ...] [-option ...]
.SH DESCRIPTION
.sp
\fBXrooms\fP is an implementation of rooms for X.  It organizes
windows into related groups, called \(lqrooms.\(rq   A room typically
contains all of the windows relating to a particular task or context; reading 
mail or developing a particular application, for example.  \fBXrooms\fP 
manages the position and state of the windows in each room, and makes it easy 
for users to switch from room to room.
.sp
\fBXrooms\fP is not a window manager;  it cooperates with ICCCM compliant
window managers, iconfying, de-iconifying, and reconfiguring windows whenever
the user switches rooms.   Because they do not recognize the standard 
mechanisms for changing windows, \fBXrooms\fP may not work with some older, 
non-ICCCM compliant window managers, \fBXrooms\fP accepts a number of options 
to use some common but non-standard methods for reconfiguring windows, and
can be made to work with any window manager that allows clients to reconfigure,
iconify, and de-iconify themselves.   \fBXrset\fP is an application that
you can use from another shell, a shell-script, or a window manager menu
to modify your rooms and applications.
.sp 2
.SH OPTIONS
\fBXrooms\fP accepts all of the standard X Toolkit command line options as well as the following:
.TP 8
.B \-allrooms
Set the default visibility for all rooms to \fIAlways\fP.
.TP 8
.B \-appnameatom " atom name"
Annotate application top level windows with a property of the specified
name which contains the name that \fBxrooms\fP uses for the application.
The default name for this property is _XROOMS_APP_NAME.
.TP 8
.B \-appstransient
Set the default permanence for applications that are not specified in
your .xroomsrc to \fITransient\fP (default).
.TP 8
.B \-appspermanent
Set the default permanence for applications that are not specified in
your .xroomsrc to \fIPermanent\fP (default).
.TP 8
.B \-autorooms
Set the default visibility for all rooms to \fIWhenNonEmpty WhenActive\fP.
.TP 8
.B \-backup
Create a backup of your .xroomsrc in .xroomsrc.bak before overwriting it 
the first time.
.TP 8
.B \-btncols
Set the number of room buttons per row in the main window.
.TP 8
.B \-config " file name"
Read configuration information from the specified file instead of the
file .xroomsrc in your home directory.
.TP 8
.B \-debug " debugging values"
Set debugging variables in \fBxrooms\fP if it was compiled -DDEBUG.
.TP 8
.B \-dfltroom " room name"
Set the name of the default room to the specified value.
.TP
.B \-iconifyfirst
.TP 8
.B \-iconifylast
Set the the order that applications are changed when you enter a room.
If you choose \fB-iconifyfirst\fP, those applications that are
iconic in the new room are iconified first, then applications are moved
as necessary;  finally, those applications that should be open in the new
room are de-iconified.    If you specify \fB-iconifylast\fP, the order
is reversed:  first de-iconify, then move, then de-iconify.   The X server
generates many fewer events when you iconify first, so changing rooms is 
faster.   Some X clients have a race condition that may cause them to exit
if they are iconified unexpectedly; these applications may disappear
if you run \fB-iconifyfirst\fP.    The default is \fB-iconifyfirst\fP; you
should only change this if you notice applications dying.
.TP 8
.B \-ignoreappnames
Do \fBnot\fP use the \fC_XROOMS_APP_NAME\fP property to determine the name of 
an application whenever the name resolution template in your .xroomsrc fails 
to find an application name.  When this flag is specified, \fBxrooms\fP will 
use the \fCWM_NAME\fP or \fCWM_ICON_NAME\fP property depending on the setting 
of the \fBUseWindowNames\fP resource.   Use this flag if a previous invocation
of \fBxrooms\fP has stored incorrect application names for some windows.
.TP 8
.B \-namelookup " template name"
Use the named template to determine application names.  \fBXrooms\fP uses the
template named \(lqChooseAppName\(rq by default.
.TP 8
.B \-setupmode 
Start in set-up mode if the user does not have a profile file.  
This is the default.
.TP 8
.B \-noconfirm
Do not ask the user if she really wants to exit \fBxrooms\fP.  Exit
immediately.
.TP 8
.B \-nogeometries
Do not manage application geometries in rooms;  track only window state.
.TP 8
.B \-noappnameatom
Do not annotate application top level windows with a property containing
the name that \fBxrooms\fP uses for the application.
.TP 8
.B \-nosetupmode 
Do not enter set-up mode automatically if the user does not have a profile
file.
.TP 8
.B \-notransients
Do not manage any windows with the property \fCWM_TRANSIENT_FOR\fP.
This is the default.  Note that \fImwm\fP considers its icon box to be 
a transient window.
.TP 8
.B \-noversion
Do not print version identification when \fBxrooms\fP is started.  This
is the default.
.TP 8
.B \-nowarnings
Do not print any warning messages.
.TP 8
.B \-nowithdrawn
Do not manage withdrawn windows.   Treat withdrawn windows as if they
were closed.    This is the default.  Note that the state of transient 
applications is \fBnot\fP preserved if the application is withdrawn.
.TP 8
.B \-saverooms
Save the local state of permanent applications in each room with the room
profile in your .xroomsrc.
.TP 8
.B \-saveapps
Save the local state of permanent applications in each room with the 
application profile in your .xroomsrc.
.TP 8
.B \-transients
Manage windows that have the \fCWM_TRANSIENT_FOR\fP property.   Use this
flag if you want \fBxrooms\fP to manage the \fImwm\fP icon box.   \fBXrooms\fP
runs a little more slowly if \fB-transients\fP is defined.
.TP 8
.B \-useappnames
Look for the \fC_XROOMS_APP_NAME\fP property to determine the name of an 
application if the name resolution template in your .xroomsrc fails to find an
application name.  This is the default.   If an application window does not 
have this property, \fBxrooms\fP will use the \fCWM_NAME\fP or 
\fCWM_ICON_NAME\fP property depending on the setting of the 
\fBUseWindowNames\fP resource.
.TP 8
.B \-useiconnames
Use the \fCWM_ICON_NAME\fP property to determine the name of an application if
the name resolution template in your .xroomsrc fails to find an
application name.  This is the default.
.TP 8
.B \-usewinnames
Use the \fCWM_NAME\fP property to determine the name of an application if
the name resolution template in your .xroomsrc fails to find an 
application name, and the window has no \fC_XROOMS_APP_NAME\fP.
.TP 8
.B \-version
.br
Print a version identification string when \fBxrooms\fP starts.
.TP 8
.B \-warnings
Print warning messages.  This is the default.
.TP 8
.B \-withdrawn
Manage withdrawn windows.
.sp
\fBXrooms\fP works best with ICCCM compliant window managers (such as mwm
or release 4 twm).  Use the following arguments to tell \fBxrooms\fP to try 
some of these non-standard methods for reconfiguring windows:
.TP 8
.B \-nonicccm
Use this flag whenever you use a non-ICCCM compliant window manager.
\fBXrooms\fP also accepts the argument \(lq\fB-icccm\fP.\(rq
.TP 8
.B \-fakeroot
Use this flag if your window manager reparents all windows into a pseudo-root
window.    Note that the heuristics that \fBxrooms\fP uses to find the 
pseudo-root window work with dxwm, but may not work with all window 
managers.   \fBXrooms\fP also accepts the \(lq\fB-realroot\fP\(rq argument.
.TP 8
.B \-fakestate
Use this flag if your window manager does not always attach the \fCWM_STATE\fP
property to application windows.   The \fB-fakestate\fP argument tells
\fBxrooms\fP to manage all windows with a \fCWM_NAME\fP property, and to assume
that all unmapped windows with \fCWM_NAME\fP and without \fCWM_STATE\fP 
are iconified. Note that this flag may cause unexpected behavior for any 
windows an application has withdrawn.
.TP 8
.B \-unmapforgeom
Use this flag to unmap and remap client windows whenever \fBxrooms\fP
reconfigures a window.
.TP 8
.B \-unmapforstate
Use this flag to unmap and remap client windows whenever \fBxrooms\fP
changes the state of a window.
.TP 8
.B \-dxwm
.br
Sets \fB-nonicccm\fP, \fB-fakeroot\fP, \fB-reopenforgeom\fP, and 
\fB-fakestate\fP.    \fBXrooms\fP cannot move windows unless you
specify \fB-unmapforgeom\fP, but this has some unusual side-effects,
particularly in setup mode and for transient apps.   You might want
to experiment, but we recommend you keep your window positions
consistent across your rooms.
.TP 8
.sp 2
.SH TERMINOLOGY
.sp
Each top-level X window is an application.   If an X client creates
more than one window, \fBxrooms\fP considers each window to be a different
application.  
.sp
A \fIpermanent\fP application has consistent behavior across
invocations of the application; i.e. if the X window that corresponds to a
permanent application is closed, any subsequent window with the same 
application name will appear in the same place in all rooms as the previous
window.  The placement and state of a transient application is not affected
by the state of earlier windows with the same name.  \fBXrooms\fP writes 
profiles for permanent applications in your .xroomsrc file, but does not 
record the profiles of transient applications.
.sp
An application state describes a real or desired appearance of an 
application window.  An application state is essentially a \fIwindow state\fP
and an X geometry specification.
.sp
The window state may be any of Normal (Open), Iconic, Withdrawn, or Inactive.
A normal window is open and visible on the screen.   An iconic window is not 
visible, but has a visible icon which represents it.  A withdrawn window 
exists, but is hidden and does not have an icon.  An inactive window is a
placeholder for the window of a permanent application that is not currently 
running.  \fBXrooms\fP will not modify withdrawn or inactive windows.
.sp
A real application state always completely describes the appearance of the 
window at the current time.  A desired state corresponds to one or
more rooms, and describes the appearance a window should have whenever 
one of those rooms is active.   Real application states must be fully
specified with positive values of X and Y; desired states may have unspecified
parts, and negative values of X or Y.   
.sp
An application has a current state, a default state, and may have 
a number of room states.  The current state is fully specified and always
matches the state of the window. When a window changes state, \fBxrooms\fP
updates the current state of the corresponding application.    Each room
state corresponds to one specific room, and describes the geometry and state 
the application should have whenever that room is active.  The default
state describes the appearance the application should take in any room that
does not have an explicit room state.  An application is local to a room 
if it has a room state specific to that room.   A room is empty when
it has no active local applications.
.sp
A room is visible whenever \fBxrooms\fP displays a button for that
room.   A room may be made visible or hidden explicitly, or may have some
combination of several automatic visibility controls.   \fBXrooms\fP checks
automatic visibility controls whenever a room is activated or an application
changes state.  A room that is \fIAlways\fP visible becomes visible if hidden
whenever \fBxrooms\fP checks visibility.  A rooms that is visible 
\fIwhenActive\fP is visible as long as it is active;  if such a room is 
deactivated and no other automatic visibility controls apply, the button for
the room will disappear.    The button for a room that is visible 
\fIwhenNonEmpty\fP is displayed whenever that room has at least one application
with local state.   When the last local application exits, the button for the
room disappears unless some other automatic visibility control applies to the
room.   By default, rooms are visible when active or non-empty.  To make rooms
be always visible, specify \fB-allrooms\fP on the command line when you start
\fBxrooms\fP.
.sp 2
.SH "STARTING XROOMS"
.sp
On startup, \fBxrooms\fP looks for the file .xroomsrc in your home directory
for a profile of the rules you use to choose application names, the permanent 
applications you expect, and the rooms you use.   If you start \fBxrooms\fP
without a profile file, some of the defaults specified above are changed
to values more appropriate for setting up your profile.  This different
set of defaults is called set-up mode.  You can disable the set-up
mode defaults by specifying \fB-nosetupmode\fP on the command line.
You can explicitly enter or leave set-up mode with the \(lqEnable/Disable Set-up
Mode\(rq menu item.  Set-up mode is automatically disabled whenever you save 
your profile to a file.
.sp
The default name of the first room that \fBxrooms\fP creates in \(lqMain.\(rq
Use the \fB-dfltroom\fP flag to specify a different name.
.sp
Under normal operation, any application for which \fBxrooms\fP does not 
have a profile starts open in the room in which it first appears and 
iconic everywhere else.   
This is usually correct behavior when \fBxrooms\fP is already set up and you 
are starting a single new application.  When you first invoke \fBxrooms\fP, 
however, all applications first appear in the default room.   If you were to 
create another room and switch to it, all of your applications, including 
\fBxrooms\fP, any icon boxes, clocks etc would be iconified.    In set-up
mode, \fBxrooms\fP tries to identify its control panel, any icon boxes, 
clocks, load monitors, or biffs, and initialize these applications 
to be open in every room.
.sp
By default, applications are transient.   If your profile is already correct,
and you start some X client, say \(lqxfd\(rq, you don't necessarily want all 
future invocations of xfd to start up open only in the room you were in the 
first time you ran \(lqxfd\(rq.  We assume you are arranging your normal
working set of windows in setup mode, so all applications are permanent.
.sp
The options in the \(lqChange States\(rq menu normally expect you to
choose a single application to modify.    In set-up mode, you can select
multiple applications.   To cancel the crosshair cursor, and stop modifying 
application states, select the root window, or press any two mouse buttons 
simultaneously.
.sp
Once \fBxrooms\fP is started, you can create rooms using the menu, and
customize each room using familiar window manager commands and the
options in the \(lqChange States\(rq menu.   Once you have all rooms set 
up the way you like them, save your .xroomsc using the \(lqSave Profile\(rq 
choice in the main menu.   Setup mode ends automatically when you save to a 
profile file.
.sp 2
.SH "PROFILE FILES"
.sp
\fBXrooms\fP looks for setup information in the file \(lq.xroomsrc\(rq in 
your home directory.   An \fBxrooms\fP profile file consists of three sections.
The sharp character `#' comments to the end of any line in your profile.
.sp
We will discuss the first section of a profile file, application name 
profiles, in the section \fBAPPLICATION NAMES\fP below.    
.sp
The second section contains application profiles -- a description of each 
permanent application you have defined.   Each profile contains the 
name of the application, the default state of the application, and an
optional list of room states for the application.   Here are some example
application profiles:
.BX
application "xrooms"       [ normal =325x100-305-5 ]
application "xterm-right"  [ iconic ] {
       "Work"              [ normal =-5+35 ]
}
application "xeyes"        [ normal =150x100+5+5 ] {
       "Work"              [ normal =-5+5 ]
       "Mail"              [ normal =150x100-5-5 ]
       "News"              [ normal =+5-5 ]
}
.EX
The application named \fBxrooms\fP is open and has the same geometry in all 
rooms.  The application named \fBxterm-right\fP is iconic in all rooms except
\(lqMail,\(rq and \fBxeyes\fP moves from corner to corner as you switch rooms.
The \fBxeyes\fP is in the top left corner of any room that is not listed 
explicitly.
.sp
The room profiles follow the application profiles in your .xroomsrc file.
The syntax of room profiles is similar to that of application profiles;
a room profile consists of a room name, the visibility of the room, and
an optional list of local applications.   Here are some example room
profiles:
.BX
room "Work"           visible always {
     "xterm-right"     [ normal =-5+30 ]
     "xterm-left"      [ normal =+5+60 ]
     "xeyes"           [ normal =-5+5 ]
}
room "Mail"           visible whenNonEmpty whenActive {
     "Mail-Read"       [ normal =500x650+25+85 ]
}
room "Games"          visible whenNonEmpty  {
     "Xtank"           [ normal =+0+0 ]
}
room "TopSecret"      hidden
.EX
The Work room might contain two terminal emulators and xeyes, but 
some or all of these applications might not be active at any given time.    
The button for this room is displayed at all times, even if none of the local
applications are are active.
.sp
The \(lqMail\(rq room contains a mail reader window.  The button for the
room is displayed whenever you are in mail room or the mail reader is
active.  
.sp
The button for the \(lqGames\(rq room is visible only when \fBXtank\fP is
active;  as soon as \fBXtank\fP exits, the button for the room will
disappear.  If you are in the games room, xrooms will move you to your
default room.
.sp
The button for the \(lqTopSecret\(rq room is never visible unless it is
explicitly exposed using the \fBxrset\fP command.
.sp
You might note that it is possible for room profiles and application
profiles to conflict, as the profiles for \fBxterm-right\fP and \(lqWork\(rq
do, above.    When \fBxrooms\fP writes a profile file, it writes local 
states with either the room profiles or the application profiles.   The
\fB-saverooms\fP and \fB-saveapps\fP options specify which set of profiles 
should list the local states.   The default is to list local states in the room
profiles.
.sp 2
.SH "APPLICATION NAMES"
.sp
\fBXrooms\fP assumes that application names are unique, but it is not always 
straightforward to uniquely identify windows.    X defines two standard 
window name properties, \fCWM_NAME\fP and \fCWM_ICON_NAME\fP, but it is 
common for several windows to have the same icon or title bar name.
.sp
Some applications change their title bar or icon names to reflect changes
in the application.   To help you identify these applications, \fBxrooms\fP
prints a warning message if your .xroomsrc does not have an application
name profile and an application changes one of the \fCWM_NAME\fP or
\fCWM_ICON_NAME\fP properties, and your .xroomsrc does not have an 
application name profile.  You can disable this check and warning message
with the \fB-nowarnings\fP flag.  This section describes the tools that 
\fBxrooms\fP includes to help you name applications consistently every time.
.sp
To insure that application names are unique, \fBxrooms\fP appends a
\(lq-number\(rq prefix to any application whose name clashes with
another running application.   For example, the first \fBxterm\fP that
\fBxrooms\fP encounters might be named \(lqxterm,\(rq the second
\(lqxterm-1,\(rq and so on.    Unfortunately, there is no guarantee that
any subsequent invocation of \fBxrooms\fP will assign the suffixes in the
same order.
.sp
To help solve this ordering problem, \fBxrooms\fP attaches the
property \fC_XROOMS_APP_NAME\fP to each client window.  This property contains 
the name that \fBxrooms\fP chose for the application, to each client window.   
When \fBxrooms\fP starts up, it looks first for the \fC_XROOMS_APP_NAME\fP
property, then for \fCWM_ICON_NAME\fP, and finally for a \fCWM_NAME\fP 
property.   To use a different property for the application name, use the 
\fB-appnameatom\fP option, or the \fB-noappnameatom\fP flag to attach 
no property.   To ignore existing \fC_XROOMS_APP_NAME\fP properties
when \fBxrooms\fP is invoked, use the \fB-ignoreappnames\fP option (this is
useful if some earlier invocation of \fBxrooms\fP has decorated all of the
windows with the wrong names).   
.sp
The application name profile in your .xroomsrc is a better solution to the 
problem of application name resolution.    The application name profile
is one or more templates in a small programming language that \fBxrooms\fP 
interprets.   This language allows you to examine and modify window properties,
compare strings to regular expressions (and extract sub-expressions), and
concatenate strings.
.sp
Each template has a name, and you can choose the name of the
template to use to resolve names with the \fB-namelookup\fP option on the
command line.  If you do not specify a template name, \fBxrooms\fP looks
for a template named \(lqChooseAppName.\(rq
.sp
Each template has a name and a body of statements and expressions.  The
legal types of string expressions are:
.sp
Property names enclosed in angle brackets: \fC<_XROOMS_APP_NAME>\fP, for 
example.  The value of a property is the string value of the named property
on the window whose name we are resolving.   A property that is a list of 
strings is concatenated with a single space. A property of type 
\fCWM_SIZE_HINTS\fP is converted to an X syntax geometry, and a property of
type \fCWM_STATE\fP is converted to one of \(lqnormal,\(rq \(lqiconic,\(rq
\(lqwithdrawn,\(rq or \(lqinactive.\(rq
.sp
String literals, surrounded by double quotes, or identifiers.   The only
identifier that is defined right now is \fIcurrentroom\fP, which returns
the name of the current room.
.sp
Concatenation:   The \(lq+\(rq operator may be used to concatenate any
two string expressions.
.sp
Conditional expression, with syntax similar to the C conditional expression:
.BX
( BooleanExpr  ?  StringExpr : StringExpr )
.EX
The legal boolean expressions are:
.sp
Regular expression comparison, where the left hand side is a regular expression;
the expression returns True if the right hand side matches the expression.
.BX
StringExpr == StringExpr
.EX
Any string expression can be used in place of a boolean;  any non-NULL
string evaluates to True.    The operator \(lq!\(rq may be used to negate
any boolean expression.
Legal statements are:
.BX
if ( BooleanExpr ) Statement [ else Statement ]
.EX
A fairly traditional if statement, with a twist.  If the BooleanExpr
was a regular expression comparison, any sub-expressions may be included
in string literals in the else statement as \(lq\\1\(r1, \(lq\\2\(rq, etc.
If the BooleanExpr was some other string expression, the entire string
is accesible as \(lq\\1.\(rq   There is no string to substitute in the
else clause, or if the boolean expression was a negation.  Sub-expressions
in the regular expression are delineated with \\( and \\).
.BX
switch ( StringExpr) {
    case StringExpr:  Statement
	:
    [ default: Statement ]
}
.EX
A switch statement.  Each case label is a regular expression which is
compared in turn against the switch expression.    The first case that
matches is executed.   Any sub-expressions in the case expression may
be included in string literals of the associated statements.  Unlike C,
each case terminates at its successsor.
.BX
use StringExpr
ignore
.EX
If the StringExpr for a use statement evaluates to non-NULL, the use statement 
returns a value to be used as the application name and no more statements
are evaluated (like a C return statement).   If the StringExpr evaluates to
NULL, the remaining statements are evaluated.  The ignore statement tells
\fBxrooms\fP not to manage this window.
The lanaguage also includes a C-like block statement, and an assignment 
statement: 
.BX
{
   Statement 1
   Statement 2
     ...
   Statment N
}

<PROPERTY> = StringExpr
Identifier = StringExpr
.EX
Assigning a string to a <PROPERTY> attaches a property of type \fCXA_STRING\fP,
with the specified name to the window being examined.   Any previous contents 
of the property are lost.   If a template assigns a string to the identifier 
\fIcurrentroom\fP \fBxrooms\fP will switch to a room with that name.   If
no such room exists, \fBxrooms\fP creates it first.
.sp
Here are some examples of name templates:
.BX
# Some programs change the name in their title
# bar or icon.   Dxmail likes to insert folder 
# names; this expression extracts the type of window
# So I get "Mail-Read," "Mail-Create" and so on.
# Likewise, the calendar puts the current time and
# date in the icon and a file name in the title
# bar.
names "ChooseAppName" {
    use <_XROOMS_APP_NAME>
    switch <WM_NAME> {
       case "iconbox":         use "iconbox"
       case "Mail: *\\([^ 	]*\\).*":	use "Mail-\\1"
       case ".*[Cc]alendar.*":	use "Calendar"
    }
    if ( <WM_TRANSIENT_FOR> )	ignore
    if ( <_XROOMS_IGNORE_ME> )	ignore
    use <WM_ICON_NAME>
    use <WM_NAME>
}
# Here is a hack you can use to specify unique names for 
# all of your applications.   The toolkit accepts any 
# string after an -xrm argument.    ICCCM compliant 
# applications report the entire command line that 
# was used to invoke them, so...
name "HackInstanceName" {
    if ( WM_COMMAND == ".*InstanceName:\\([^ ]*\\).*" )
	use \1
    ignore
}
.EX
.sp 2
.SH "BOLTS"
.sp
Bolts are a feature unique to \fBxrooms\fP (we think).   Any part of an
application state may be bolted.   Normally, when the state of a window
changes, \fBxrooms\fP notes the change and preserves the new state.  If
a part of the state is bolted, however, \fBxrooms\fP will restore that
part of the state.   Exclamation points specify bolts in your .xroomsrc, or 
you may use the \fBxrooms\fP menu.  To bolt the window state of an application
from a profile file, follow the window state with an exclamation point. 
For example if the room Work is specified like this:
.BX
room "Work"           visible always {
     "xterm-right"     [ normal! =-5+30 ]
     "xterm-left"      [ normal! =+5+60 ]
     "xeyes"           [ normal =-5+5 ]
}
.EX
You cannot iconify either xterm.  If you do, \fBxrooms\fP will immediately
reopen them.
.sp
To bolt some parts of a geometry:
.BX
application "xeyes"        [ normal =150x100+5+5 ] {
       "Work"              [ normal =-5+5 xy! ]
       "Mail"              [ normal! =150x100-5-5 whxy! ]
       "News"              [ normal =+5-5 x! ]
}
.EX
In the room \(lqWork,\(rq you can resize xeyes, but \fBxrooms\fP will keep
the upper right hand corner of xeyes in the upper right hand corner of
the screen.   In the Mail room, \fBxrooms\fP will undo any changes you
make to xeyes.   In the News rooms, you can resize xeyes at will, and move
it anywhere along the left side of the screen.
.sp
It's a long story.  We know this doesn't belong in rooms, but we think
its neat.  
.sp 2
.SH "COMMAND MENU"
.sp
Click and release the middle button anywhere in the \fBxrooms\fP control
panel to invoke the main menu.   The menu will stay posted until you select
a menu item with the left mouse button.   To cancel a menu, select the
\(lqClose Menu\(rq option in either menu.
.sp
Most of the options on the command menu are straightforward.  The entries
on the \(lqChange States\(rq menu modify the profiled states of individual
applications.  Each entry gives you a crosshair cursor to select the 
application you want to modify.  To cancel any choice, select
the root window, or press any two mouse buttons simultaneously.
In set-up mode, you can select more than one application.  The crosshairs
cursor will stay until you cancel the operation.  Be sure not to click on
a window unless you want to modify some part of its state.
.sp
The \(lqOpen In All Rooms,\(rq \(lqOpen Here Only,\(rq \(lqBolt Geometry,\(rq
and \(lqUnbolt Geometry\(rq selections all affect different parts of an 
application state depending on where you click in the application window and 
how you sweep the mouse after you click.   Clicking in any corner specifies
the corresponding positive or negative values for X and Y.  Clicking
along the edge of a window specifies only one of X or Y, as appropriate.
Sweeping across more that a third of the width of a window modifies
the width part of the application state, and likewise for height.  
.sp
The \(lqOpen In All Rooms\(rq selection sets the state of the selected 
application in all rooms to be open, with the currently visible geometry.  
It removes all local states and sets the default to the visible state.   
any bolts on the application state are cleared.   The \fBxrooms\fP program
will store only those parts of the state that you select as described above.
For example, if you click and release in the upper left corner of a window 
whose real geometry is \(lq=100x100+100+100\(rq and the screen is 1000 pixels
in each dimension, the default geometry of the application will be set 
to  \(lq=+100+100.\(rq   If you click and release on the lower right corner, 
\fBxrooms\fP will use the geometry \(lq=-800-800.\(rq   If you click halfway
down the left edge of the window and sweep the mouse to the lower right hand 
corner before you release the button, \fBxrooms\fP will use the geometry
\(lq=100x100+100.\(rq
.sp
The \(lqOpen Local Only\(rq selection sets the default state of the selected 
application to iconic with the currently visible geometry, and the local 
state to the visible state.  This command also uses the mouse press location 
and drag to determine which parts are set as described above.
.sp
The \(lqBolt Geometry\(rq and \(lqUnbolt Geometry\(rq bolt or unbolt the parts 
of the application geometry specified by your mouse location and sweep.
The bolt operation bolts the state of x or y as it is defined in the state.
Clicking in any corner bolts both x and y; clicking along an edge selects
either x or y.   If the profiled state of the application described above
is \(lq=+100+100\(rq, clicking along the right edge will bolt the geometry
as specfied, i.e. \(lq=+100+100 x!\(rq -- to bolt the right edge of the
application, you must first change the profiled state using the \(lqOpen
Local Only\(rq menu item or the \fBxrset\fP command.
.sp
The \(lqBolt Window Open\(rq and \(lqUnbolt Window State\(rq operations 
affect \fBonly\fP the window state of the specified application; they do not
affect any bolts on the geometry.   Click anywhere in the application
to bolt or unbolt the window state.
.sp
The bolt and unbolt operations affect the visible state of the application 
in the current room.   If the application has a state local to the current
room, only that state is changed.   If the application in not local to the
current room, the default state is updated.
.sp
The \(lqMake Permanent\(rq and \(lqMake Transient\(rq affect the application
as a whole, not a specific state.   Click anywhere in the window to
change the permanence of an application.
.sp 2
.SH "OTHER FEATURES"
.sp
The \fBxrooms\fP program can communicate with other programs through a 
property on the root window.   Right now, it recognizes requests to change 
application state, permanence, room visibility, and to load profile 
information (the same format as your .xroomsrc).   The program \fBxrset\fP 
can be used by shell-scripts and window manager menus to control the state 
of your rooms and applications.   Unfortunately, \fBxrset\fP is rather poorly
documented this release.  Be brave.  It's useful.  It has one heck of 
a usage screen.
.sp
\fBXrooms\fP stores the name of the current room in a property 
\fC_XROOMS_CURRENT\fP on the root window.  A program \fBwallpaper\fP, 
watches this property and invokes a command specified in your .wallpaperrc.   
You can use this to give each room a distinctive background.
.sp
The property \fC_XROOMS_APP_NAME\fP contains a list of all visible rooms.
.sp
.SH "SEE ALSO"
X(1)
.sp 2
.SH BUGS
.sp
The \fBxrooms\fP program does not preserve the stacking order of windows
in a room.
.sp 2
.SH COPYRIGHT
Copyright 1990, Digital Equipment Corp.
.sp 2
.SH AUTHORS
.sp
Erik Fortune, Terry Weissman, Mike Yang (All DEC-UEG-WSL)
Please send bug reports, comments, or suggestions to:
xrooms@wsl.dec.com
