#ifndef APPSTATESTR_H
#define	APPSTATESTR_H

  /*\
   *  $Header: appstatestr.h,v 5.0 90/01/10 06:53:17 erik Exp $
   *
   *		              COPYRIGHT 1990
   *		        DIGITAL EQUIPMENT CORPORATION
   *		           MAYNARD, MASSACHUSETTS
   *			    ALL RIGHTS RESERVED.
   *
   * THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE WITHOUT NOTICE AND
   * SHOULD NOT BE CONSTRUED AS A COMMITMENT BY DIGITAL EQUIPMENT CORPORATION.
   * DIGITAL MAKES NO REPRESENTATIONS ABOUT THE SUITABILITY OF THIS SOFTWARE 
   * FOR ANY PURPOSE.  IT IS SUPPLIED "AS IS" WITHOUT EXPRESS OR IMPLIED 
   * WARRANTY.
   *
   * IF THE SOFTWARE IS MODIFIED IN A MANNER CREATING DERIVATIVE COPYRIGHT
   * RIGHTS, APPROPRIATE LEGENDS MAY BE PLACED ON THE DERIVATIVE WORK IN
   * ADDITION TO THAT SET FORTH ABOVE.
   *
   * Permission to use, copy, modify, and distribute this software and its
   * documentation for any purpose and without fee is hereby granted, provided
   * that the above copyright notice appear in all copies and that both that
   * copyright notice and this permission notice appear in supporting
   * documentation, and that the name of Digital Equipment Corporation not be
   * used in advertising or publicity pertaining to distribution of the 
   * software without specific, written prior permission.
  \*/

#include "appstate.h"

typedef struct _AppStateRec {
	unsigned	flags;
	unsigned	bolts;
	unsigned	looseBolts;
	WinState	winState;
	int		x,y;
	unsigned	width,height;
} AppStateRec;

#define	AS_DFLT_SCREEN_WIDTH	1024
#define	AS_DFLT_SCREEN_HEIGHT	864

#define	ASHasX(s)		((s)&&((s)->flags&asXValue))
#define	ASHasY(s)		((s)&&((s)->flags&asYValue))
#define	ASHasWidth(s)		((s)&&((s)->flags&asWidthValue))
#define	ASHasHeight(s)		((s)&&((s)->flags&asHeightValue))
#define	ASHasWinState(s)	((s)&&((s)->flags&asWinStateValue))
#define	ASHasAny(s)		((s)&&(((s)->flags&asAllValues)!=asNoValue))
#define	ASHasAll(s)		((s)&&(((s)->flags&asAllValues)==asAllValues))
#define	ASHasWholeGeom(s)	((s)&&(((s)->flags&asGeomValues)==asGeomValues))
#define	ASHasAnyGeom(s)		((s)&&(((s)->flags&asGeomValues)!=asNoValue))
#define	ASHasNegativeX(s)	((s)&&((s)->flags&asXNegative))
#define	ASHasNegativeY(s)	((s)&&((s)->flags&asYNegative))

#define	ASLegalRealState(s)	(((s)!=NullAppState)&&ASHasAll(s)&&\
				 (!ASHasNegativeX(s))&&(!ASHasNegativeY(s))&&\
				 ((s)->bolts==asNoValue)&&\
				 ((s)->looseBolts==asNoValue))
#define	ASLegalProfileState(s)	(((s)==NullAppState)||(!ASHasWinState(s))||\
				 (((s)->winState!=asInactive)&&\
				  ((s)->winState!=asWithdrawn)))
#define	ASDontCareState(s)	(((s)==NullAppState)||(!ASHasAny(s)))

#define	ASWinStateBolted(s)	((s)&&((s)->bolts&asWinStateValue))
#define	ASXBolted(s)		((s)&&((s)->bolts&asXValue))
#define	ASYBolted(s)		((s)&&((s)->bolts&asYValue))
#define	ASWidthBolted(s)	((s)&&((s)->bolts&asWidthValue))
#define	ASHeightBolted(s)	((s)&&((s)->bolts&asHeightValue))
#define	ASAnyBolted(s)		((s)&&(((s)->bolts&asAllValues)!=asNoValue))
#define	ASAnyGeomBolted(s)	((s)&&(((s)->bolts&asGeomValues)!=asNoValue))

#endif /* APPSTATESTR_H */
