#ifndef NAMESSTR_H
#define	NAMESSTR_H 1

  /*\
   *  $Header: namesstr.h,v 5.0 90/01/10 06:53:45 erik Exp $
   *
   *		              COPYRIGHT 1990
   *		        DIGITAL EQUIPMENT CORPORATION
   *		           MAYNARD, MASSACHUSETTS
   *			    ALL RIGHTS RESERVED.
   *
   * THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE WITHOUT NOTICE AND
   * SHOULD NOT BE CONSTRUED AS A COMMITMENT BY DIGITAL EQUIPMENT CORPORATION.
   * DIGITAL MAKES NO REPRESENTATIONS ABOUT THE SUITABILITY OF THIS SOFTWARE 
   * FOR ANY PURPOSE.  IT IS SUPPLIED "AS IS" WITHOUT EXPRESS OR IMPLIED 
   * WARRANTY.
   *
   * IF THE SOFTWARE IS MODIFIED IN A MANNER CREATING DERIVATIVE COPYRIGHT
   * RIGHTS, APPROPRIATE LEGENDS MAY BE PLACED ON THE DERIVATIVE WORK IN
   * ADDITION TO THAT SET FORTH ABOVE.
   *
   * Permission to use, copy, modify, and distribute this software and its
   * documentation for any purpose and without fee is hereby granted, provided
   * that the above copyright notice appear in all copies and that both that
   * copyright notice and this permission notice appear in supporting
   * documentation, and that the name of Digital Equipment Corporation not be
   * used in advertising or publicity pertaining to distribution of the 
   * software without specific, written prior permission.
  \*/

#include "regex.h"
#include "names.h"

typedef struct _NPStateRec {
	Boolean		 done;
	char		*resultName;
	char		*resultClass;
	char		*lastMatchString;
	RXMatchesRec	 lastMatchSubStrings;
	NameResolveFunc	 ResolveFunc;
	ChangeNamedFunc	 ChangeFunc;
	Opaque		 OSPrivate;
} NPStateRec;

typedef	struct	_NPQuestionExprRec {
	NPBoolExprPtr	pCondition;
	NPStringExprPtr	pTrue;
	NPStringExprPtr	pFalse;
} NPQuestionExprRec, *NPQuestionExprPtr;

typedef struct	_NPConcatExprRec {
	NPStringExprPtr	pLeft;
	NPStringExprPtr	pRight;
} NPConcatExprRec, *NPConcatExprPtr;

typedef struct	_NPStringExprRec {
	unsigned		 type;
	union {
	    char		*constant;
	    NPConcatExprRec	 concat;
	    NPQuestionExprRec	 conditional;
	} u;
} NPStringExprRec;

typedef struct	_NPBoolExprRec {
	Boolean		invert;
	NPStringExprPtr	left;
	NPStringExprPtr	right;
} NPBoolExprRec;

typedef	struct	_NPIfStatementRec {
	NPBoolExprPtr	 condition;
	NPStatementPtr	 thenClause;
	NPStatementPtr	 elseClause;
} NPIfStatementRec,*NPIfStatementPtr;
#define	NullNPIfStatement	((NPIfStatementPtr)NULL)

typedef struct _NPCaseRec {
	NPStringExprPtr		 pattern;
	NPStatementPtr		 statement;
	struct _NPCaseRec	*pNext;
} NPCaseRec;

typedef struct _NPSwitchStatementRec {
	NPStringExprPtr	 string;
	NPStatementPtr	 dfltCase;
	NPCasePtr	 cases;
} NPSwitchStatementRec, *NPSwitchStatementPtr;
#define	NullNPSwitchStatement	((NPSwitchStatementPtr)NULL)

typedef struct _NPAssignStatementRec {
	Boolean			 append;
	NPStringExprPtr		 pLHS;	/* identifier or property only! */
	NPStringExprPtr		 pValue;
} NPAssignStatementRec, *NPAssignStatementPtr;
#define	NullNPAssignStatementRec	((NPAssignStatementPtr)NULL)

typedef	struct	_NPStatementRec {
	unsigned	what;
	union {
	    NPIfStatementRec		ifS;
	    NPSwitchStatementRec	switchS;
	    NPStringExprPtr		pUseExpr;
	    NPStringExprPtr		pClassExpr;
	    NPAssignStatementRec	assignS;
	    char			*comment;
	} u;
	struct _NPStatementRec	*pNext;
} NPStatementRec;

#define	NPIfStatement		((unsigned)(1<<0))
#define	NPSwitchStatement	((unsigned)(1<<1))
#define	NPUseStatement		((unsigned)(1<<2))
#define	NPClassStatement	((unsigned)(1<<3))
#define	NPIgnoreStatement	((unsigned)(1<<4))
#define	NPAssignStatement	((unsigned)(1<<5))
#define	NPComment		((unsigned)(1<<9))

#endif /* NAMESSTR_H */
