#ifndef PROFPARSER_H
#define	PROFPARSER_H 1

  /*\
   *  $Header: profparser.h,v 5.0 90/01/10 06:54:00 erik Exp $
   *
   *		              COPYRIGHT 1990
   *		        DIGITAL EQUIPMENT CORPORATION
   *		           MAYNARD, MASSACHUSETTS
   *			    ALL RIGHTS RESERVED.
   *
   * THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE WITHOUT NOTICE AND
   * SHOULD NOT BE CONSTRUED AS A COMMITMENT BY DIGITAL EQUIPMENT CORPORATION.
   * DIGITAL MAKES NO REPRESENTATIONS ABOUT THE SUITABILITY OF THIS SOFTWARE 
   * FOR ANY PURPOSE.  IT IS SUPPLIED "AS IS" WITHOUT EXPRESS OR IMPLIED 
   * WARRANTY.
   *
   * IF THE SOFTWARE IS MODIFIED IN A MANNER CREATING DERIVATIVE COPYRIGHT
   * RIGHTS, APPROPRIATE LEGENDS MAY BE PLACED ON THE DERIVATIVE WORK IN
   * ADDITION TO THAT SET FORTH ABOVE.
   *
   * Permission to use, copy, modify, and distribute this software and its
   * documentation for any purpose and without fee is hereby granted, provided
   * that the above copyright notice appear in all copies and that both that
   * copyright notice and this permission notice appear in supporting
   * documentation, and that the name of Digital Equipment Corporation not be
   * used in advertising or publicity pertaining to distribution of the 
   * software without specific, written prior permission.
  \*/

#include "strtbl.h"
#include "appstate.h"
#include "rooms.h"
#include "apps.h"
#include "profile.h"
#include "profscan.h"
#include "names.h"

typedef struct _ParserWinStateRec {
	WinState	winState;
	Boolean		bolted;
} ParserWinStateRec, *ParserWinStatePtr;

typedef struct _ParserNamedStateRec {
	StringToken	name;
	AppStatePtr	pState;
} ParserNamedStateRec,*ParserNamedStatePtr;

typedef struct _ParserStateRec {
	union {
	    ParserWinStateRec	ws;
	    AppStatePtr		pGeomState;
	    ParserNamedStateRec	state;
	} u;
	struct _ParserStateRec	*pNext;
} ParserStateRec,*ParserStatePtr;
#define	NullParserState	((ParserStatePtr)NULL)

extern	RoomPtr		parserCreateRoom(/* nameStr, pStates */);
extern	AppPtr		parserCreateApp(/* nameStr, pDflt, pStates */);

extern	AppStatePtr	parserCreateState(/* pPWinState, pPGeom */);
extern	ParserStatePtr	parserAppendState(/* pState1, pState2 */);
extern	ParserStatePtr	parserCreateNamedState(/* nameStr, pState */);
extern	ParserStatePtr	parserCreateWinState(/* winState, bolted */);
extern	ParserStatePtr	parserCreateGeom(/* pGeom, bolted */);
#endif /* PROFPARSER_H */
