#ifndef ROOMS_H
#define ROOMS_H 1

  /*\
   *  $Header: rooms.h,v 5.0 90/01/10 06:54:28 erik Exp $
   *
   *		              COPYRIGHT 1990
   *		        DIGITAL EQUIPMENT CORPORATION
   *		           MAYNARD, MASSACHUSETTS
   *			    ALL RIGHTS RESERVED.
   *
   * THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE WITHOUT NOTICE AND
   * SHOULD NOT BE CONSTRUED AS A COMMITMENT BY DIGITAL EQUIPMENT CORPORATION.
   * DIGITAL MAKES NO REPRESENTATIONS ABOUT THE SUITABILITY OF THIS SOFTWARE 
   * FOR ANY PURPOSE.  IT IS SUPPLIED "AS IS" WITHOUT EXPRESS OR IMPLIED 
   * WARRANTY.
   *
   * IF THE SOFTWARE IS MODIFIED IN A MANNER CREATING DERIVATIVE COPYRIGHT
   * RIGHTS, APPROPRIATE LEGENDS MAY BE PLACED ON THE DERIVATIVE WORK IN
   * ADDITION TO THAT SET FORTH ABOVE.
   *
   * Permission to use, copy, modify, and distribute this software and its
   * documentation for any purpose and without fee is hereby granted, provided
   * that the above copyright notice appear in all copies and that both that
   * copyright notice and this permission notice appear in supporting
   * documentation, and that the name of Digital Equipment Corporation not be
   * used in advertising or publicity pertaining to distribution of the 
   * software without specific, written prior permission.
  \*/

	/*\
	 * Operations on rooms
	\*/

#include "room.h"

typedef	Boolean	(*RoomsIterFunc)(/* pRoom, arg */);
typedef RoomPtr	(*RoomFinderFunc)();

extern	unsigned int	roomsDebug;

extern	int		NumberOfRooms();

extern	RoomPtr		LookupRoom(/* name */);
extern	RoomPtr		CreateRoom(/* name */);
extern	Boolean		DestroyRoom(/* pRoom */);
extern	void		RoomsIterate(/* func, arg */);

extern	Boolean		SwitchToRoom(/* pRoom */);
extern	RoomPtr		GetCurrentRoom();

extern	void		SetDefaultRoomFinder(/* pFinder */);
extern	void		SetDefaultRoomFeedback(/* pFunc */);

extern	Boolean		_RoomsInitIter(/* pState */);
extern	Boolean		_RoomsIterNext(/* pState, ppRoom */);
extern	Boolean		_RoomsIterNextVisible(/* pState, ppRoom */);
extern	void		RoomsEndIterator(/* state */);

#define	RoomsIterator(pa,s)	\
	if (_RoomsInitIter(&(s))) \
	    while (_RoomsIterNext((s),&(pa)))

#define	VisibleRoomsIterator(pa,s)	\
	if (_RoomsInitIter(&(s))) \
	    while (_RoomsIterNext((s),&(pa)))

#endif /* ROOMS_H */
