#ifndef ROOMSTR_H
#define	ROOMSTR_H 1

  /*\
   *  $Header: roomstr.h,v 5.0 90/01/10 06:54:31 erik Exp $
   *
   *		              COPYRIGHT 1990
   *		        DIGITAL EQUIPMENT CORPORATION
   *		           MAYNARD, MASSACHUSETTS
   *			    ALL RIGHTS RESERVED.
   *
   * THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE WITHOUT NOTICE AND
   * SHOULD NOT BE CONSTRUED AS A COMMITMENT BY DIGITAL EQUIPMENT CORPORATION.
   * DIGITAL MAKES NO REPRESENTATIONS ABOUT THE SUITABILITY OF THIS SOFTWARE 
   * FOR ANY PURPOSE.  IT IS SUPPLIED "AS IS" WITHOUT EXPRESS OR IMPLIED 
   * WARRANTY.
   *
   * IF THE SOFTWARE IS MODIFIED IN A MANNER CREATING DERIVATIVE COPYRIGHT
   * RIGHTS, APPROPRIATE LEGENDS MAY BE PLACED ON THE DERIVATIVE WORK IN
   * ADDITION TO THAT SET FORTH ABOVE.
   *
   * Permission to use, copy, modify, and distribute this software and its
   * documentation for any purpose and without fee is hereby granted, provided
   * that the above copyright notice appear in all copies and that both that
   * copyright notice and this permission notice appear in supporting
   * documentation, and that the name of Digital Equipment Corporation not be
   * used in advertising or publicity pertaining to distribution of the 
   * software without specific, written prior permission.
  \*/

#include "list.h"
#include "room.h"

typedef struct _RoomRec {
	StringToken	 name;
	Boolean		 active;
	unsigned	 visibility;
	int		 numApps;
	int		 numLocalApps;
	ListPtr	 	 contents;
	Opaque		 priv;
	RoomFeedbackFunc feedback;
} RoomRec;

typedef	struct _RoomAppInfoRec {
	AppPtr		pApp;
	AppStatePtr	pDefault;
	AppStatePtr	pReal;
	AppStatePtr	pLocal;
} RoomAppInfoRec,*RoomAppInfoPtr;
#define	NullRoomAppInfo	((RoomAppInfoPtr)NULL)

	/* macros to make room.c more readable */
#define	_HasLocalState(r,ri)	((ri)->pLocal!=NullAppState)
#define	_GetVisibleState(r,ri)	((ri)->pLocal!=NullAppState?\
					(ri)->pLocal:\
					((ri)->pDefault))

#define	_HasLocalApps(r)		((r)->numLocalApps>0)
#define	_NoLocalApps(r)		((r)->numLocalApps<1)

#define	_Feedback(r,w,a)	if ((r)->feedback!=(RoomFeedbackFunc)NULL) {\
					((*(r)->feedback)(r,w,a));\
				}

#define	_IsActive(r)		((r)->active)
#define	_IsInactive(r)		(!(r)->active)

#define	_IsVisible(r)		((r)->visibility&roomVisible)
#define	_IsHidden(r)		(!_IsVisible(r))
#define	_WhenActive(r)		((r)->visibility&roomWhenActive)
#define	_WhenNonEmpty(r)	((r)->visibility&roomWhenNonEmpty)
#define	_Always(r)		((r)->visibility&roomAlways)

#define	_SetVisible(r)		((r)->visibility|=roomVisible)
#define	_SetHidden(r)		((r)->visibility&=(~roomVisible))

#define	_RealStateIsWrong(r,ri,v)	\
		(_IsActive(r)&&(!asRealMatchesProfile((ri)->pReal,(v))))
#define	_CheckRealState(r,ri) {\
	AppStatePtr	vis=	_GetVisibleState(r,ri);\
	if (_RealStateIsWrong(r,ri,vis)) {\
	    appSetCurrent((ri)->pApp,vis,False);\
	}}

#define	_LocalAppGone(pr)	{\
	(pr)->numLocalApps--;\
	if ((!_Always(pr))&&_IsVisible(pr)&&\
	    _WhenNonEmpty(pr)&&_NoLocalApps(pr)) {\
	    if ((!_WhenActive(pr))||(_IsInactive(pr))) {\
		_SetHidden(pr);\
		_Feedback(pr,roomFBHidden,NullApp);\
	    }\
	}}

#define	_LocalAppAdded(pr)	{\
	(pr)->numLocalApps++;\
	if (_WhenNonEmpty(pr)&&_IsHidden(pr)) {\
	    _SetVisible(pr);\
	    _Feedback(pr,roomFBVisible,NullApp);\
	}}

#endif /* ROOMSTR_H */
