#ifndef HASH_H
#define	HASH_H 1

  /*\
   *  $Header: hash.h,v 5.0 90/01/10 06:50:48 erik Exp $
   *
   *		              COPYRIGHT 1990
   *		        DIGITAL EQUIPMENT CORPORATION
   *		           MAYNARD, MASSACHUSETTS
   *			    ALL RIGHTS RESERVED.
   *
   * THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE WITHOUT NOTICE AND
   * SHOULD NOT BE CONSTRUED AS A COMMITMENT BY DIGITAL EQUIPMENT CORPORATION.
   * DIGITAL MAKES NO REPRESENTATIONS ABOUT THE SUITABILITY OF THIS SOFTWARE 
   * FOR ANY PURPOSE.  IT IS SUPPLIED "AS IS" WITHOUT EXPRESS OR IMPLIED 
   * WARRANTY.
   *
   * IF THE SOFTWARE IS MODIFIED IN A MANNER CREATING DERIVATIVE COPYRIGHT
   * RIGHTS, APPROPRIATE LEGENDS MAY BE PLACED ON THE DERIVATIVE WORK IN
   * ADDITION TO THAT SET FORTH ABOVE.
   *
   * Permission to use, copy, modify, and distribute this software and its
   * documentation for any purpose and without fee is hereby granted, provided
   * that the above copyright notice appear in all copies and that both that
   * copyright notice and this permission notice appear in supporting
   * documentation, and that the name of Digital Equipment Corporation not be
   * used in advertising or publicity pertaining to distribution of the 
   * software without specific, written prior permission.
  \*/

#include "storage.h"

typedef	struct	_HashTableRec		*HashTablePtr;
#define	NullHashTable		((HashTablePtr)NULL)

typedef	Boolean			(*HashIterFunc)(/* row, key, pData, arg */);

extern	HashTablePtr	htCreate(/* size, keyType, dataType */);
extern	void		htDestroy(/* table */);

extern	GenData		htAdd(/* table, key, data */);
extern	GenData		htLookup(/* table, key */);
extern	GenData		htRemove(/* table, key */);

extern	int		htSize(/* table */);
extern	int		htNumStored(/* table */);

extern	Boolean		htResize(/* table, newSize */);
extern	Boolean		htConvertKeys(/* table, cvtFunc, keyDesc */);
extern	Boolean		htConvertData(/* table, cvtFunc, dataDesc */);
extern	Boolean		htChangeHashFunc(/* table, newFunc */);

extern	void		htIterate(/* table, pFunc, arg */);

extern	Boolean		_htInitIter(/* table, ppData */);
extern	Boolean		_htIterNext(/* table, pState, ppData */);
extern	void		htEndIterator(/* table, state */);

#define	htIterator(t,k,d,s)	\
	if (_htInitIter((t),&(s))) \
	    while (_htIterNext((t),(Opaque)(s),(GenKey *)&(k),(GenData *)&(d))) 

#endif /* HASH_H */
