#ifndef LIST_H
#define LIST_H 1

  /*\
   *  $Header: list.h,v 5.0 90/01/10 06:50:58 erik Exp $
   *
   *		              COPYRIGHT 1990
   *		        DIGITAL EQUIPMENT CORPORATION
   *		           MAYNARD, MASSACHUSETTS
   *			    ALL RIGHTS RESERVED.
   *
   * THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE WITHOUT NOTICE AND
   * SHOULD NOT BE CONSTRUED AS A COMMITMENT BY DIGITAL EQUIPMENT CORPORATION.
   * DIGITAL MAKES NO REPRESENTATIONS ABOUT THE SUITABILITY OF THIS SOFTWARE 
   * FOR ANY PURPOSE.  IT IS SUPPLIED "AS IS" WITHOUT EXPRESS OR IMPLIED 
   * WARRANTY.
   *
   * IF THE SOFTWARE IS MODIFIED IN A MANNER CREATING DERIVATIVE COPYRIGHT
   * RIGHTS, APPROPRIATE LEGENDS MAY BE PLACED ON THE DERIVATIVE WORK IN
   * ADDITION TO THAT SET FORTH ABOVE.
   *
   * Permission to use, copy, modify, and distribute this software and its
   * documentation for any purpose and without fee is hereby granted, provided
   * that the above copyright notice appear in all copies and that both that
   * copyright notice and this permission notice appear in supporting
   * documentation, and that the name of Digital Equipment Corporation not be
   * used in advertising or publicity pertaining to distribution of the 
   * software without specific, written prior permission.
  \*/

#include "storage.h"

typedef struct _ListRec	*ListPtr;
typedef Comparison	(*ListSortFunc)(/* key1, key2 */);
#define	NullList	((ListPtr)NULL)
#define	NullListSortFunc	((ListSortFunc)NULL)

extern	unsigned	listDebug;

extern	ListPtr	 	lCreate(/* size, sortFunc, keyType, dataType */);
extern	void		lDestroy(/* pList */);

extern	int		lNItems(/* pList */);

extern	Boolean		lAdd(/* pList, key, data */);
extern	Boolean		lStore(/* pList, key, data */);
extern	Boolean		lRemove(/* pList, key */);
extern	Boolean		lRemoveAll(/* pList */);
extern	Boolean		lLookup(/* pList, key, pNItems, ppData */);

extern	void		lIterate(/* pList, pFunc, arg */);

extern	Boolean		_lInitIter(/* pList, ppData */);
extern	Boolean		_lIterNext(/* pList, pState, ppData */);
extern	void		lEndIterator(/* pList, state */);

#define	lIterator(l,k,d,s)	\
	if (_lInitIter((l),&s)) \
	    while (_lIterNext((l),&(s),(GenKey *)&(k),(GenData *)&(d)))

#endif /* LIST_H */
