#ifndef STORAGE_H
#define	STORAGE_H 1

  /*\
   *  $Header: storage.h,v 5.0 90/01/10 06:51:17 erik Exp $
   *
   *		              COPYRIGHT 1990
   *		        DIGITAL EQUIPMENT CORPORATION
   *		           MAYNARD, MASSACHUSETTS
   *			    ALL RIGHTS RESERVED.
   *
   * THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE WITHOUT NOTICE AND
   * SHOULD NOT BE CONSTRUED AS A COMMITMENT BY DIGITAL EQUIPMENT CORPORATION.
   * DIGITAL MAKES NO REPRESENTATIONS ABOUT THE SUITABILITY OF THIS SOFTWARE 
   * FOR ANY PURPOSE.  IT IS SUPPLIED "AS IS" WITHOUT EXPRESS OR IMPLIED 
   * WARRANTY.
   *
   * IF THE SOFTWARE IS MODIFIED IN A MANNER CREATING DERIVATIVE COPYRIGHT
   * RIGHTS, APPROPRIATE LEGENDS MAY BE PLACED ON THE DERIVATIVE WORK IN
   * ADDITION TO THAT SET FORTH ABOVE.
   *
   * Permission to use, copy, modify, and distribute this software and its
   * documentation for any purpose and without fee is hereby granted, provided
   * that the above copyright notice appear in all copies and that both that
   * copyright notice and this permission notice appear in supporting
   * documentation, and that the name of Digital Equipment Corporation not be
   * used in advertising or publicity pertaining to distribution of the 
   * software without specific, written prior permission.
  \*/

	/*\
	 * Declarations for generic storage structure keys and
	 * data.
	\*/

typedef	unsigned long		 GenKey;
typedef	unsigned long		 GenData;

typedef	int		(*HashFunc)(/* key */);
typedef	GenKey		(*KeyConvertFunc)(/* oldKey */);
typedef	GenData		(*DataConvertFunc)(/* oldData */);
typedef	Boolean		(*GenIterFunc)(/* key, data, arg */);

typedef	struct	_GenKeyDescRec	*GenKeyDescPtr;
typedef	struct	_GenDataDescRec	*GenDataDescPtr;

#define	NullGenKeyDesc		((GenKeyDescPtr)NULL)
#define	NullGenDataDesc		((GenDataDescPtr)NULL)

extern	int		genHashString(/* key */);
extern	GenKey		genReplaceStringData(/* oldData */);
extern	GenData		genDupStringData(/* data */);
extern	Comparison	genCompareStringKey(/* key1, key2 */);

extern	GenKeyDescPtr	genStringKeyType;
extern	GenKeyDescPtr	genFreedStringKeyType;
extern	GenKeyDescPtr	genIntegerKeyType;
extern	GenKeyDescPtr	genDefaultKeyType;

extern	GenDataDescPtr	genFreedStringDataType;
extern	GenDataDescPtr	genPointerDataType;
extern	GenDataDescPtr	genFreedPointerDataType;
extern	GenDataDescPtr	genIntegerDataType;
extern	GenDataDescPtr	genDefaultDataType;

#endif /* ifndef STORAGE_H */
