
  /*\
   *  $Header: utils.c,v 5.0 90/01/10 06:51:32 erik Exp $
   *
   *		              COPYRIGHT 1990
   *		        DIGITAL EQUIPMENT CORPORATION
   *		           MAYNARD, MASSACHUSETTS
   *			    ALL RIGHTS RESERVED.
   *
   * THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE WITHOUT NOTICE AND
   * SHOULD NOT BE CONSTRUED AS A COMMITMENT BY DIGITAL EQUIPMENT CORPORATION.
   * DIGITAL MAKES NO REPRESENTATIONS ABOUT THE SUITABILITY OF THIS SOFTWARE 
   * FOR ANY PURPOSE.  IT IS SUPPLIED "AS IS" WITHOUT EXPRESS OR IMPLIED 
   * WARRANTY.
   *
   * IF THE SOFTWARE IS MODIFIED IN A MANNER CREATING DERIVATIVE COPYRIGHT
   * RIGHTS, APPROPRIATE LEGENDS MAY BE PLACED ON THE DERIVATIVE WORK IN
   * ADDITION TO THAT SET FORTH ABOVE.
   *
   * Permission to use, copy, modify, and distribute this software and its
   * documentation for any purpose and without fee is hereby granted, provided
   * that the above copyright notice appear in all copies and that both that
   * copyright notice and this permission notice appear in supporting
   * documentation, and that the name of Digital Equipment Corporation not be
   * used in advertising or publicity pertaining to distribution of the 
   * software without specific, written prior permission.
  \*/

#include 	"utils.h"

/***====================================================================***/

Opaque
uAlloc(size)
unsigned	size;
{
    return((Opaque)malloc(size));
}

/***====================================================================***/

Opaque
uCalloc(n, size)
unsigned	n,size;
{
    return((Opaque)calloc(n,size));
}

/***====================================================================***/

Opaque
uRealloc(old, newSize)
Opaque		old;
unsigned	newSize;
{
    return((Opaque)realloc((char *)old,newSize));
}

/***====================================================================***/

void
uFree(ptr)
Opaque	ptr;
{
    if (ptr!=(Opaque)NULL)
	free((char *)ptr);
    return;
}

/***====================================================================***/
/***                  FUNCTION ENTRY TRACKING                           ***/
/***====================================================================***/

static	FILE	*entryFile=	stderr;
	int	 uEntryLevel;

Boolean
uSetEntryFile(name)
char	*name;
{
    if ((entryFile!=NULL)&&(entryFile!=stderr)) {
	fprintf(entryFile,"switching to %s\n",name?name:"stderr");
	fclose(entryFile);
    }
    if (name!=NullString)	entryFile=	fopen(name,"w");
    else			entryFile=	stderr;
    if (entryFile==NULL) {
	entryFile=	stderr;
	return(False);
    }
    return(True);
}

void
uEntry(l,s,a1,a2,a3,a4,a5,a6,a7,a8)
int	l;
char	*s,*a1,*a2,*a3,*a4,*a5,*a6,*a7,*a8;
{
int	i;

    for (i=0;i<uEntryLevel;i++) {
	putc(' ',entryFile);
    }
    fprintf(entryFile,s,a1,a2,a3,a4,a5,a6,a7,a8);
    uEntryLevel+= l;
    return;
}

void
uExit(l,rtVal)
int	l;
char	*rtVal;
{
int	i;

    uEntryLevel-= l;
    if (uEntryLevel<0)	uEntryLevel=	0;
    for (i=0;i<uEntryLevel;i++) {
	putc(' ',entryFile);
    }
    fprintf(entryFile,"---> 0x%x\n",rtVal);
    return;
}

/***====================================================================***/
/***			PRINT FUNCTIONS					***/
/***====================================================================***/

static	FILE	*debugFile=		stderr;
	int	 uDebugIndentLevel=	0;
	int	 uDebugIndentSize=	4;

Boolean
uSetDebugFile(name)
char	*name;
{
    if ((debugFile!=NULL)&&(debugFile!=stderr)) {
	fprintf(debugFile,"switching to %s\n",name?name:"stderr");
	fclose(debugFile);
    }
    if (name!=NullString)	debugFile=	fopen(name,"w");
    else			debugFile=	stderr;
    if (debugFile==NULL) {
	debugFile=	stderr;
	return(False);
    }
    return(True);
}

void
uDebug(s,a1,a2,a3,a4,a5,a6,a7,a8)
char	*s,*a1,*a2,*a3,*a4,*a5,*a6,*a7,*a8;
{
int	i;

    for (i=(uDebugIndentLevel*uDebugIndentSize);i>0;i--) {
	putc(' ',debugFile);
    }
    fprintf(debugFile,s,a1,a2,a3,a4,a5,a6,a7,a8);
    fflush(debugFile);
    return;
}

/***====================================================================***/

static	FILE	*errorFile=	stderr;

Boolean
uSetErrorFile(name)
char	*name;
{
    if ((errorFile!=NULL)&&(errorFile!=stderr)) {
	fprintf(errorFile,"switching to %s\n",name?name:"stderr");
	fclose(errorFile);
    }
    if (name!=NullString)	errorFile=	fopen(name,"w");
    else			errorFile=	stderr;
    if (errorFile==NULL) {
	errorFile=	stderr;
	return(False);
    }
    return(True);
}

void
uInformation(s,a1,a2,a3,a4,a5,a6,a7,a8)
char	*s,*a1,*a2,*a3,*a4,*a5,*a6,*a7,*a8;
{
    fprintf(errorFile,s,a1,a2,a3,a4,a5,a6,a7,a8);
    fflush(errorFile);
    return;
}

/***====================================================================***/

void
uAction(s,a1,a2,a3,a4,a5,a6,a7,a8)
char	*s,*a1,*a2,*a3,*a4,*a5,*a6,*a7,*a8;
{
    fprintf(errorFile,"                  ");
    fprintf(errorFile,s,a1,a2,a3,a4,a5,a6,a7,a8);
    fflush(errorFile);
    return;
}

/***====================================================================***/

void
uWarning(s,a1,a2,a3,a4,a5,a6,a7,a8)
char	*s,*a1,*a2,*a3,*a4,*a5,*a6,*a7,*a8;
{
    fprintf(errorFile,"Warning:          ");
    fprintf(errorFile,s,a1,a2,a3,a4,a5,a6,a7,a8);
    fflush(errorFile);
    return;
}

/***====================================================================***/

void
uError(s,a1,a2,a3,a4,a5,a6,a7,a8)
char	*s,*a1,*a2,*a3,*a4,*a5,*a6,*a7,*a8;
{
    fprintf(errorFile,"Error:            ");
    fprintf(errorFile,s,a1,a2,a3,a4,a5,a6,a7,a8);
    fflush(errorFile);
    return;
}

/***====================================================================***/

void
uFatalError(s,a1,a2,a3,a4,a5,a6,a7,a8)
char	*s,*a1,*a2,*a3,*a4,*a5,*a6,*a7,*a8;
{
    fprintf(errorFile,"Fatal Error:      ");
    fprintf(errorFile,s,a1,a2,a3,a4,a5,a6,a7,a8);
    fprintf(errorFile,"                  Exiting\n");
    fflush(errorFile);
    exit(1);
    /* NOTREACHED */
}

/***====================================================================***/

void
uInternalError(s,a1,a2,a3,a4,a5,a6,a7,a8)
char	*s,*a1,*a2,*a3,*a4,*a5,*a6,*a7,*a8;
{
    fprintf(errorFile,"Internal error:   ");
    fprintf(errorFile,s,a1,a2,a3,a4,a5,a6,a7,a8);
    fflush(errorFile);
    return;
}

/***====================================================================***/
/***			STRING HELPER FUNCTIONS				***/
/***====================================================================***/

char		*
uStringDup(str)
char	*str;
{
char	*new;

    if (!str)	return(NULL);

    new= (char *)uAlloc((unsigned)strlen(str)+1);
    if (!new)	return(NULL);
    strcpy(new,str);
    return(new);
}

#ifndef NO_TIMEOUTS
/***====================================================================***/
/***			TIMER HELPER FUNCTIONS				***/
/***====================================================================***/

#include <signal.h>
#include <sys/time.h>

void
uSetTimeout(seconds,milliSeconds,pFunc)
int	seconds;
int	milliSeconds;
void	(*pFunc)();
{
struct itimerval	time,otime;
struct sigvec		sig,osig;

    sig.sv_handler=	pFunc;
    sig.sv_mask=	0;
    sig.sv_flags=	SV_INTERRUPT;
    sigvec(SIGALRM,&sig,&osig);
    timerclear(&time.it_interval);
    time.it_value.tv_sec=	seconds;
    time.it_value.tv_usec=	milliSeconds;
    setitimer(ITIMER_REAL,&time,&otime);
    return;
}

void
uClearTimeout()
{
struct itimerval	time,otime;
struct sigvec		sig,osig;

    sig.sv_handler=	SIG_DFL;
    sig.sv_mask=	0;
    sig.sv_flags=	0;
    sigvec(SIGALRM,&sig,&osig);
    timerclear(&time.it_interval);
    timerclear(&time.it_value);
    setitimer(ITIMER_REAL,&time,&otime);
    return;
}
#endif
