#define MAXROOMS 100

  /*\
   *  $Header: wallpaper.c,v 5.0 90/01/10 07:05:05 erik Exp $
   *
   *		              COPYRIGHT 1990
   *		        DIGITAL EQUIPMENT CORPORATION
   *		           MAYNARD, MASSACHUSETTS
   *			    ALL RIGHTS RESERVED.
   *
   * THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE WITHOUT NOTICE AND
   * SHOULD NOT BE CONSTRUED AS A COMMITMENT BY DIGITAL EQUIPMENT CORPORATION.
   * DIGITAL MAKES NO REPRESENTATIONS ABOUT THE SUITABILITY OF THIS SOFTWARE 
   * FOR ANY PURPOSE.  IT IS SUPPLIED "AS IS" WITHOUT EXPRESS OR IMPLIED 
   * WARRANTY.
   *
   * IF THE SOFTWARE IS MODIFIED IN A MANNER CREATING DERIVATIVE COPYRIGHT
   * RIGHTS, APPROPRIATE LEGENDS MAY BE PLACED ON THE DERIVATIVE WORK IN
   * ADDITION TO THAT SET FORTH ABOVE.
   *
   * Permission to use, copy, modify, and distribute this software and its
   * documentation for any purpose and without fee is hereby granted, provided
   * that the above copyright notice appear in all copies and that both that
   * copyright notice and this permission notice appear in supporting
   * documentation, and that the name of Digital Equipment Corporation not be
   * used in advertising or publicity pertaining to distribution of the 
   * software without specific, written prior permission.
  \*/

#include <stdio.h>
#include <strings.h>
#include <malloc.h>
#include <X11/Xlib.h>

typedef struct _RoomInfoRec {
    char *name;
    Atom atom;
    char *cmd;
} RoomInfoRec, *RoomInfo;

Display *dpy;
RoomInfoRec rooms[MAXROOMS];
int numrooms = 0;
Atom ROOMS_CURRENT;

Punt(str)
  char *str;
{
    fprintf(stderr, "%s\n", str);
    exit(1);
}

char *MallocACopy(str)
  char *str;
{
    return strcpy(malloc((unsigned) strlen(str)+1),str);
}

main(argc, argv)
    int argc;
    char **argv;
{
    char homeDir[512], buf[1024], *ptr, *ptr2;
    char *displayname = NULL;
    XEvent event;
    int i;
    FILE *fid;
    Atom oldroom, curroom;
    Atom actualtype;
    unsigned long actualformat, nitems, bytesafter;
    char *propreturn = NULL;


    for (i=1 ; i<argc ; i++) {
	if (argv[i][0] == '-' && argv[i][1] == 'd' && i < argc - 1) {
	    displayname = argv[++i];
	} else {
	    Punt("Usage: wallpaper [-display displayname]\n");
	}
    }

    strcpy(homeDir, getenv("HOME"));
    (void) sprintf(buf, "%s/.wallpaperrc", homeDir);
    fid = fopen(buf, "r");
    if (!fid)
	Punt(".wallpaperrc not found!\n");

    dpy = XOpenDisplay(displayname);
    if (!dpy)
	Punt("Can't open display!");
    displayname = DisplayString(dpy);

    while (fgets(buf, 1024, fid)) {
	ptr = index(buf, '\n');
	if (ptr) *ptr = 0;
	for (ptr = buf ; *ptr ; ptr++) {
	    if (*ptr == ' ' || *ptr == '\t') break;
	}
	if (*ptr == 0) continue;
	*ptr++ = 0;
	rooms[numrooms].name = MallocACopy(buf);
	while (*ptr == ' ' || *ptr == '\t') ptr++;
	if (*ptr == 0) continue;
	if (!index(ptr, '$')) {
	    rooms[numrooms].cmd = MallocACopy(ptr);
	} else {
	    rooms[numrooms].cmd =
		malloc(strlen(ptr) + 5 * strlen(displayname));
	    rooms[numrooms].cmd[0] = 0;
	    ptr2 = index(ptr, '$');
	    while (ptr2) {
		*ptr2++ = 0;
		strcat(rooms[numrooms].cmd, ptr);
		if (strncmp(ptr2, "DISPLAY", 7) == 0) {
		    strcat(rooms[numrooms].cmd, displayname);
		    ptr2 += 7;
		}
		ptr = ptr2;
		ptr2 = index(ptr, '$');
	    }
	    strcat(rooms[numrooms].cmd, ptr);
	}
	rooms[numrooms].atom = XInternAtom(dpy, rooms[numrooms].name, False);
	numrooms++;
    }
    (void) fclose(fid);

    XSelectInput(dpy, DefaultRootWindow(dpy), PropertyChangeMask);

    ROOMS_CURRENT = XInternAtom(dpy, "_XROOMS_CURRENT", False);

    oldroom = 0;
    for (;;) {
	if (XGetWindowProperty(dpy, DefaultRootWindow(dpy), ROOMS_CURRENT, 0,
			       1, False, AnyPropertyType, &actualtype,
			       &actualformat, &nitems, &bytesafter,
			       &propreturn) == Success) {
	    curroom = *((Atom *) propreturn);
	    if (curroom != oldroom) {
		for (i=0 ; i<numrooms ; i++) {
		    if (rooms[i].atom == curroom) {
			system(rooms[i].cmd);
			break;
		    }
		}
		oldroom = curroom;
	    }
	}
	XNextEvent(dpy, &event);
    }
}
