
  /*\
   *  $Header: xrActions.c,v 5.3 90/01/11 14:10:25 erik Exp $
   *
   *		              COPYRIGHT 1990
   *		        DIGITAL EQUIPMENT CORPORATION
   *		           MAYNARD, MASSACHUSETTS
   *			    ALL RIGHTS RESERVED.
   *
   * THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE WITHOUT NOTICE AND
   * SHOULD NOT BE CONSTRUED AS A COMMITMENT BY DIGITAL EQUIPMENT CORPORATION.
   * DIGITAL MAKES NO REPRESENTATIONS ABOUT THE SUITABILITY OF THIS SOFTWARE 
   * FOR ANY PURPOSE.  IT IS SUPPLIED "AS IS" WITHOUT EXPRESS OR IMPLIED 
   * WARRANTY.
   *
   * IF THE SOFTWARE IS MODIFIED IN A MANNER CREATING DERIVATIVE COPYRIGHT
   * RIGHTS, APPROPRIATE LEGENDS MAY BE PLACED ON THE DERIVATIVE WORK IN
   * ADDITION TO THAT SET FORTH ABOVE.
   *
   * Permission to use, copy, modify, and distribute this software and its
   * documentation for any purpose and without fee is hereby granted, provided
   * that the above copyright notice appear in all copies and that both that
   * copyright notice and this permission notice appear in supporting
   * documentation, and that the name of Digital Equipment Corporation not be
   * used in advertising or publicity pertaining to distribution of the 
   * software without specific, written prior permission.
  \*/

#include <X11/Xlib.h>
#include <X11/cursorfont.h>
#include <X11/Xutil.h>

#define	DEBUG_VAR	xractDebug
#include "utils.h"
#include "hash.h"

#include "appstate.h"
#include "apps.h"
#include "rooms.h"

#include "xrDebug.h"
#include "xrXUtils.h"
#include "xrApp.h"
#include "xrGen.h"
#include "xrProtoArgs.h"
#include "xrProtoIter.h"
#include "xrActions.h"
#include "xrooms.h"

extern void xruiPopDownWinMenu();

/***====================================================================***/

void
xractDoSetAll()
{
xrSetStateArgsRec	args;
    xruiPopDownWinMenu();
    args.doWhat=	'S'; 		/* set */
    args.toWhat=	'P'; 		/* parts */
    args.whichPart=	XR_QUERY_PARTS; /* let the user decide */
    args.whichState=	XR_ALL_STATES;	/* clobber everything */
    if (xroomsSetupMode)
	 args.whichApp= XR_QUERY_MULT_APPS;	/* pick a bunch */
    else args.whichApp=	XR_QUERY_APP;		/* let the user decide */
    args.appName=	NULL;		/* no name needed */
    args.whichRoom=	XR_CURRENT_ROOM;/* take current room */
    args.roomName=	NULL;		/* no name needed */
    xrdpDoSetState(&args);
    return;
}

/***====================================================================***/

void
xractDoSetLocalOnly()
{
AppPtr		pApp;
AppStatePtr	pState;
RoomPtr		pRoom;
Opaque		ristate;

    xruiPopDownWinMenu();
    xractDoSetAll();
    pApp= xrpaGetLastApp();
    pRoom= GetCurrentRoom();
    if ((pApp!=NullApp)&&(pRoom!=NullRoom)) {
	pState= appGetDefault(pApp);
	appSetRoomState(pApp,roomName(pRoom),pState,False);
	asChangeSelected(pState,asWinStateValue,asIconic,0,0,(unsigned)0,
							(unsigned)0);
	RoomsIterator(pRoom,ristate) {
	    roomCheckAppStates(pRoom,pApp);
	}
	RoomsEndIterator(ristate);
    }
    return;
}

/***====================================================================***/

static xrRememberArgsRec remArgs = {
	True,	XR_QUERY_APP, 	0
};

void
xractDoMakePermanent()
{
    xruiPopDownWinMenu();
    remArgs.remember=	True;
    xrdpDoRemember(&remArgs);
    return;
}

/***====================================================================***/

void
xractDoMakeTransient()
{
    xruiPopDownWinMenu();
    remArgs.remember=	False;
    xrdpDoRemember(&remArgs);
    return;
}

/***====================================================================***/

void
xractDoBoltGeom()
{
xrSetStateArgsRec	args;

    xruiPopDownWinMenu();
    args.doWhat=	'S'; 			/* set */
    args.toWhat=	'B'; 			/* bolts */
    args.whichPart=	XR_QUERY_PARTS; 	/* let the user decide */
    args.whichState=	XR_VISIBLE_STATE;	/* take visible state */
    if (xroomsSetupMode)
	 args.whichApp= XR_QUERY_MULT_APPS;	/* pick a bunch */
    else args.whichApp=	XR_QUERY_APP;		/* let the user decide */
    args.appName=	NULL;			/* no name needed */
    args.whichRoom=	XR_CURRENT_ROOM;	/* take current room */
    args.roomName=	NULL;			/* no name needed */
    xrdpDoBolt(&args);
    return;
}

/***====================================================================***/

void
xractDoUnboltGeom()
{
xrSetStateArgsRec	args;
    xruiPopDownWinMenu();
    args.doWhat=	'C'; 			/* clear */
    args.toWhat=	'B'; 			/* bolts */
    args.whichPart=	XR_QUERY_PARTS; 	/* let the user decide */
    args.whichState=	XR_VISIBLE_STATE;	/* visible state */
    if (xroomsSetupMode)
	 args.whichApp= XR_QUERY_MULT_APPS;	/* pick a bunch */
    else args.whichApp=	XR_QUERY_APP;		/* let the user decide */
    args.appName=	NULL;			/* no name needed */
    args.whichRoom=	XR_CURRENT_ROOM;	/* in current room */
    args.roomName=	NULL;			/* no name needed */
    xrdpDoBolt(&args);
    return;
}

/***====================================================================***/

void
xractDoBoltState()
{
xrSetStateArgsRec	args;
    xruiPopDownWinMenu();
    args.doWhat=	'M'; 			/* merge */
    args.toWhat=	'B'; 			/* bolts */
    args.whichPart=	XR_WINSTATE_PART;	/* window state only */
    args.whichState=	XR_VISIBLE_STATE;	/* visible state */
    if (xroomsSetupMode)
	 args.whichApp= XR_QUERY_MULT_APPS;	/* pick a bunch */
    else args.whichApp=	XR_QUERY_APP;		/* let the user decide */
    args.appName=	NULL;			/* no name needed */
    args.whichRoom=	XR_CURRENT_ROOM;	/* in current room */
    args.roomName=	NULL;			/* no name needed */
    xrdpDoBolt(&args);
    return;
}

/***====================================================================***/

void
xractDoUnboltState()
{
xrSetStateArgsRec	args;
    xruiPopDownWinMenu();
    args.doWhat=	'C'; 			/* clear */
    args.toWhat=	'B'; 			/* bolts */
    args.whichPart=	XR_WINSTATE_PART;	/* window state only */
    args.whichState=	XR_VISIBLE_STATE;	/* whichever state is visible */
    if (xroomsSetupMode)
	 args.whichApp= XR_QUERY_MULT_APPS;	/* pick a bunch */
    else args.whichApp=	XR_QUERY_APP;		/* let the user decide */
    args.appName=	NULL;			/* no name needed */
    args.whichRoom=	XR_CURRENT_ROOM;	/* in this room */
    args.roomName=	NULL;			/* no name needed */
    xrdpDoBolt(&args);
    return;
}

