#ifndef XRAPP_H
#define	XRAPP_H 1

  /*\
   *  $Header: xrApp.h,v 5.1 90/01/11 14:09:55 erik Exp $
   *
   *		              COPYRIGHT 1990
   *		        DIGITAL EQUIPMENT CORPORATION
   *		           MAYNARD, MASSACHUSETTS
   *			    ALL RIGHTS RESERVED.
   *
   * THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE WITHOUT NOTICE AND
   * SHOULD NOT BE CONSTRUED AS A COMMITMENT BY DIGITAL EQUIPMENT CORPORATION.
   * DIGITAL MAKES NO REPRESENTATIONS ABOUT THE SUITABILITY OF THIS SOFTWARE 
   * FOR ANY PURPOSE.  IT IS SUPPLIED "AS IS" WITHOUT EXPRESS OR IMPLIED 
   * WARRANTY.
   *
   * IF THE SOFTWARE IS MODIFIED IN A MANNER CREATING DERIVATIVE COPYRIGHT
   * RIGHTS, APPROPRIATE LEGENDS MAY BE PLACED ON THE DERIVATIVE WORK IN
   * ADDITION TO THAT SET FORTH ABOVE.
   *
   * Permission to use, copy, modify, and distribute this software and its
   * documentation for any purpose and without fee is hereby granted, provided
   * that the above copyright notice appear in all copies and that both that
   * copyright notice and this permission notice appear in supporting
   * documentation, and that the name of Digital Equipment Corporation not be
   * used in advertising or publicity pertaining to distribution of the 
   * software without specific, written prior permission.
  \*/

#include "app.h"

typedef struct	_XAppInfoRec {
	Window		parent,client;
	AppStatePtr	pRealState;
	struct {
	    unsigned	flags;
	    WinState	state;
	    int		x,y;
	    unsigned	w,h;
	} wants;
} XAppInfoRec, *XAppInfoPtr;
#define NullXAppInfo	((XAppInfoPtr)NULL)

#define	StateFlag	(1<<0)
#define	XFlag		(1<<1)
#define	YFlag		(1<<2)
#define	WidthFlag	(1<<3)
#define	HeightFlag	(1<<4)
#define	PositionFlags	(XFlag|YFlag)
#define	SizeFlags	(WidthFlag|HeightFlag)
#define	GeomFlags	(PositionFlags|SizeFlags)
#define	AllFlags	(StateFlag|GeomFlags)

#define	SetOn(ai,f)	((ai)->wants.flags|=(f))
#define	SetOff(ai,f)	((ai)->wants.flags&=(~(f)))
#define	On(ai,f)	((ai)->wants.flags&(f))

#define	WantsState(ai,s)	(On(ai,StateFlag)&&((ai)->wants.state==(s)))
#define	WantsX(ai,xv)		(On(ai,XFlag)&&((ai)->wants.x==(xv)))
#define	WantsY(ai,yv)		(On(ai,YFlag)&&((ai)->wants.y==(yv)))
#define	WantsWidth(ai,wv)	(On(ai,WidthFlag)&&((ai)->wants.w==(wv)))
#define	WantsHeight(ai,hv)	(On(ai,HeightFlag)&&((ai)->wants.h==(hv)))
#define	WantsAny(ai)		((ai)->wants.flags&AllFlags!=0)

#define	SetWantsState(ai,s)	(SetOn(ai,StateFlag),(ai)->wants.state=(s))
#define	SetWantsX(ai,xv)	(SetOn(ai,XFlag),(ai)->wants.x=(xv))
#define	SetWantsY(ai,yv)	(SetOn(ai,YFlag),(ai)->wants.y=(yv))
#define	SetWantsWidth(ai,wv)	(SetOn(ai,WidthFlag),(ai)->wants.w=(wv))
#define	SetWantsHeight(ai,hv)	(SetOn(ai,HeightFlag),(ai)->wants.h=(hv))
#define	SetWantsNone(ai)	((ai)->wants.flags= 0)
#define	SetWantsPos(ai,xv,yv)	(SetOn(ai,PositionFlags),(ai)->wants.x=(xv),\
							(ai)->wants.y=(yv))
#define	SetWantsSize(ai,wv,hv)	(SetOn(ai,SizeFlags),(ai)->wants.w=(wv),\
							(ai)->wants.h=(hv))

#define	GotState(ai)		(SetOff(ai,StateFlag))
#define	GotX(ai)		(SetOff(ai,XFlag))
#define	GotY(ai)		(SetOff(ai,YFlag))
#define	GotWidth(ai)		(SetOff(ai,WidthFlag))
#define	GotHeight(ai)		(SetOff(ai,HeightFlag))

extern	unsigned	xrAppDebug;
extern	void		xraDebugPrint();

extern	Boolean		xraNonICCCM;
extern	Boolean		xraDfltAppsIconic;
extern	Boolean		xraDfltAppsTransient;
extern	Boolean		xraUseGeometries;
extern	Boolean		xraReopenForGeom;
extern	Boolean		xraUnmapForGeom,xraUnmapForState;
extern	Boolean		xraManageTransients;
extern	Boolean		xraManageWithdrawn;

extern	AppPtr	xraLookupWindowApp(/*win*/);

extern	Boolean xraNonICCCMAppUpdate(/*pApp,pNewState,priv*/);
extern	Boolean	xraAppUpdate(/*pApp,pNewState,priv*/);

extern	void 	xraAddApp(/*window*/);

extern	void	xraClientResized(/*client,newW,newH*/);
extern	void	xraClientMoved(/*client,newX,newY*/);
extern	void	xraClientDestroyed(/*client*/);
extern	void	xraStateChanged(/*client*/);
extern	void	xraInit();
#endif /* XRAPP_H */
