
  /*\
   *  $Header: xrDebug.c,v 5.1 90/01/11 14:11:03 erik Exp $
   *
   *		              COPYRIGHT 1990
   *		        DIGITAL EQUIPMENT CORPORATION
   *		           MAYNARD, MASSACHUSETTS
   *			    ALL RIGHTS RESERVED.
   *
   * THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE WITHOUT NOTICE AND
   * SHOULD NOT BE CONSTRUED AS A COMMITMENT BY DIGITAL EQUIPMENT CORPORATION.
   * DIGITAL MAKES NO REPRESENTATIONS ABOUT THE SUITABILITY OF THIS SOFTWARE 
   * FOR ANY PURPOSE.  IT IS SUPPLIED "AS IS" WITHOUT EXPRESS OR IMPLIED 
   * WARRANTY.
   *
   * IF THE SOFTWARE IS MODIFIED IN A MANNER CREATING DERIVATIVE COPYRIGHT
   * RIGHTS, APPROPRIATE LEGENDS MAY BE PLACED ON THE DERIVATIVE WORK IN
   * ADDITION TO THAT SET FORTH ABOVE.
   *
   * Permission to use, copy, modify, and distribute this software and its
   * documentation for any purpose and without fee is hereby granted, provided
   * that the above copyright notice appear in all copies and that both that
   * copyright notice and this permission notice appear in supporting
   * documentation, and that the name of Digital Equipment Corporation not be
   * used in advertising or publicity pertaining to distribution of the 
   * software without specific, written prior permission.
  \*/

#include <ctype.h>
#define	DEBUG_VAR	xrdebugDebug
#include "utils.h"
#include "strtbl.h"
#include "profile.h"
#include "rooms.h"
#include "apps.h"
#include "names.h"
#include "nameprof.h"

extern	unsigned	listDebug,hashDebug,regexDebug,strtblDebug;
extern	unsigned	appDebug,roomDebug;
extern	unsigned	xroomsDebug,xrgenDebug;
extern	unsigned	parserDebug,scanDebug;

extern	void		DebugPrintRooms(/* name */);
extern	void		DebugPrintApps(/* name */);
extern	void		DebugPrintProfiles(/* name */);

/***====================================================================***/

extern	unsigned	xrAppDebug,xrdpDebug,xrRoomDebug,xruiDebug;
extern	unsigned	xrgenDebug,xrMainDebug,xrNamesDebug,xrProfileDebug;
extern	unsigned	xrprDebug,xrpaDebug,xrSetupDebug,xruDebug,xrdebugDebug;

void
xrDumpDebugVars()
{
    uDebug("hashDebug=	0x%x\n",hashDebug);
    uDebug("listDebug=	0x%x\n",listDebug);
    uDebug("regexDebug=	0x%x\n",regexDebug);
    uDebug("strtblDebug=	0x%x\n",strtblDebug);
    uDebug("asDebug=	0x%x\n",asDebug);
    uDebug("appDebug=	0x%x\n",appDebug);
    uDebug("roomDebug=	0x%x\n",roomDebug);
    uDebug("profileDebug=	0x%x\n",profileDebug);
    uDebug("namesDebug=	0x%x\n",namesDebug);
    uDebug("parserDebug=	0x%x\n",parserDebug);
    uDebug("scanDebug=	0x%x\n",scanDebug);
    uDebug("appsDebug=	0x%x\n",appsDebug);
    uDebug("roomsDebug=	0x%x\n",roomsDebug);
    uDebug("xrAppDebug=	0x%x\n",xrAppDebug);
    uDebug("xrdpDebug=	0x%x\n",xrdpDebug);
    uDebug("xrRoomDebug=	0x%x\n",xrRoomDebug);
    uDebug("xruiDebug=	0x%x\n",xruiDebug);
    uDebug("xrgenDebug=	0x%x\n",xrgenDebug);
    uDebug("xrMainDebug=	0x%x\n",xrMainDebug);
    uDebug("xrNamesDebug=	0x%x\n",xrNamesDebug);
    uDebug("xrProfileDebug=	0x%x\n",xrProfileDebug);
    uDebug("xrprDebug=	0x%x\n",xrprDebug);
    uDebug("xrpaDebug=	0x%x\n",xrpaDebug);
    uDebug("xrSetupDebug=	0x%x\n",xrSetupDebug);
    uDebug("xruDebug=	0x%x\n",xruDebug);
    uDebug("xrdebugDebug=	0x%x\n",xrdebugDebug);
    uDebug("xrgenDebug=	0x%x\n",xrgenDebug);
    return;
}

/***====================================================================***/

void
xrDebugSet(lhs,rhs)
char	*lhs,*rhs;
{
Boolean	intValue= False;
int	value;

    uENTRY2("xrDebugSet(%s,%s)\n",uStringText(lhs),uStringText(rhs));
    if (sscanf(rhs,"0x%x",&value)==1)		intValue=	True;
    else if (sscanf(rhs,"%d",&value)==1)	intValue=	True;

    if (intValue) {
	if	(uStringEqual(lhs,"hash"))	hashDebug=	value;
	else if	(uStringEqual(lhs,"list"))	listDebug=	value;
	else if	(uStringEqual(lhs,"regex"))	regexDebug=	value;
	else if	(uStringEqual(lhs,"strtbl"))	strtblDebug=	value;
	else if	(uStringEqual(lhs,"appstate"))	asDebug=	value;
	else if	(uStringEqual(lhs,"app"))	appDebug=	value;
	else if	(uStringEqual(lhs,"room"))	roomDebug=	value;
	else if	(uStringEqual(lhs,"profile"))	profileDebug=	value;
	else if	(uStringEqual(lhs,"names"))	namesDebug=	value;
	else if	(uStringEqual(lhs,"nameprof"))	nameprofDebug=	value;
	else if	(uStringEqual(lhs,"parser"))	parserDebug=	value;
	else if	(uStringEqual(lhs,"scan"))	scanDebug=	value;
	else if	(uStringEqual(lhs,"apps"))	appsDebug=	value;
	else if	(uStringEqual(lhs,"rooms"))	roomsDebug=	value;
	else if (uStringEqual(lhs,"xrapp"))	xrAppDebug=	value;
	else if (uStringEqual(lhs,"xrdp"))	xrdpDebug=	value;
	else if (uStringEqual(lhs,"xrroom"))	xrRoomDebug=	value;
	else if (uStringEqual(lhs,"xrui"))	xruiDebug=	value;
	else if (uStringEqual(lhs,"xrgen"))	xrgenDebug=	value;
	else if (uStringEqual(lhs,"xrmain"))	xrMainDebug=	value;
	else if (uStringEqual(lhs,"xrnames"))	xrNamesDebug=	value;
	else if (uStringEqual(lhs,"xrprofile"))	xrProfileDebug=	value;
	else if (uStringEqual(lhs,"xrpr"))	xrprDebug=	value;
	else if (uStringEqual(lhs,"xrpa"))	xrpaDebug=	value;
	else if (uStringEqual(lhs,"xrsetup"))	xrSetupDebug=	value;
	else if (uStringEqual(lhs,"xru"))	xruDebug=	value;
	else if	(uStringEqual(lhs,"xrdebug"))	xrdebugDebug=	value;
	else if	(uStringEqual(lhs,"xrgen"))	xrgenDebug=	value;
	else if (uStringEqual(lhs,"utils")) {
	    listDebug= hashDebug=	regexDebug=	strtblDebug=	value;
	}
	else if (uStringEqual(lhs,"low")) {
	   asDebug=	value;
	}
	else if (uStringEqual(lhs,"lib")) {
	    appDebug=		roomDebug=	asDebug=	value;
	}
	else if (uStringEqual(lhs,"app")) {
	    appsDebug=	roomsDebug=	profileDebug=	value;
	    namesDebug=	nameprofDebug=			value;
	    scanDebug=	parserDebug=			value;
	}
	else if (uStringEqual(lhs,"xrooms")) {
	    xrAppDebug=	 xrdpDebug=	xrRoomDebug=	value;
	    xruiDebug=	 xrgenDebug=	xrMainDebug=	value;
	    xrNamesDebug=	 	xrProfileDebug=	value;
	    xrprDebug=	 xrpaDebug=	xrSetupDebug=	value; 
	    xruDebug=	 xrdebugDebug=			value;
	}
	else if (uStringEqual(lhs,"all")) {
	    listDebug=	hashDebug=	regexDebug=	value;
	    strtblDebug=		asDebug=	value;
	    appDebug=	roomDebug=	asDebug=	value;
	    appsDebug=	roomsDebug=	profileDebug=	value;
	    namesDebug=	nameprofDebug=			value;
	    scanDebug=	parserDebug=			value;
	    xrAppDebug=	xrdpDebug=	xrRoomDebug=	value;
	    xruiDebug=	xrgenDebug=	xrMainDebug=	value;
	    xrNamesDebug=	 	xrProfileDebug=	value;
	    xrprDebug=	 xrpaDebug=	xrSetupDebug=	value; 
	    xruDebug=	 xrdebugDebug=			value;
	}
    }
    else {
	if (rhs[0]==NUL)	rhs=	NullString;
	if	(uStringEqual(lhs,"entry"))	uSetEntryFile(rhs);
	else if (uStringEqual(lhs,"error"))	uSetErrorFile(rhs);
	else if (uStringEqual(lhs,"debug"))	uSetDebugFile(rhs);
	else if (uStringEqual(lhs,"message"))	uDebug("%s\n",rhs);
	else if (uStringEqual(lhs,"dump")) {
	    if		(uStringEqual(rhs,"rooms"))
		DebugPrintRooms(NullString);
	    else if	(uStringEqual(rhs,"apps"))
		DebugPrintApps(NullString);
	    else if	(uStringEqual(rhs,"xapps"))
		xraDebugPrint();
	    else if	(uStringPrefix("room-",rhs))
		DebugPrintRooms(rhs+5);
	    else if	(uStringPrefix("app-",rhs))
		DebugPrintApps(rhs+4);
	    else if	(uStringEqual(rhs,"all")) {
		DebugPrintRooms(NullString);
		DebugPrintApps(NullString);
	    }
	    else {
		uDebug("weird dump command %s\n",rhs);
	    }
	}
    }
    uVOIDRETURN;
}

/***====================================================================***/

char *
xrDebugSetting(str)
char	*str;
{
char	lhs[256],rhs[256];
int	len;

    uENTRY1("xrDebugSetting(%s)\n",uStringText(str));
    if (str==NullString) {
	uRETURN(NullString);
    }
    while (((*str)!=NUL)&&isspace(*str))	str++;
    for (len=0;((*str)!=NUL)&&(!isspace(*str))&&(*str!='=')&&(len<255);str++) {
	lhs[len++]=	*str;
    }
    lhs[len++]=	NUL;
    if (*str!='=') {
	while (((*str)!=NUL)&&(isspace(*str))) {
	    str++;
	}
    }
    if (*str!='=') {
	uWarning("xrDebugSetting expected '='\n");
	uRETURN(str);
    }
    else str++;
    while (((*str)!=NUL)&&isspace(*str))	str++;
    for (len=0;((*str)!=NUL)&&(!isspace(*str))&&(*str!=',')&&(len<255);str++) {
	rhs[len++]=	*str;
    }
    rhs[len++]=	NUL;
    xrDebugSet(lhs,rhs);
    uRETURN(str);
}

/***====================================================================***/

void
xrDebugSettings(str)
char	*str;
{
    uENTRY1("xrDebugSettings(%s)\n",uStringText(str));
    while (*str!=NUL) {
	while ((*str!=NUL)&&(isspace(*str)))	str++;
	if (*str!=NUL) {
	    str= xrDebugSetting(str);
	    while ((*str!=NUL)&&isspace(*str))	str++;
	    if (*str==',')	str++;
	}
    }
    if (DEBUG_VAR&8) {
	xrDumpDebugVars();
    }
    uVOIDRETURN;
}

